#include "create.h"
#include <stdio.h>
#include <string.h>
#include <X11/Xutil.h>

void OnCreateNotify(Aswm* aswm, const XCreateWindowEvent* e) {
	printf("XCreateWindowEvent %lu on parent %lu\n", e->window, e->parent);
	printf("\tx = %i\n", e->x);
	printf("\ty = %i\n", e->y);
	printf("\tw = %i\n", e->width);
	printf("\th = %i\n", e->height);
	printf("\toverride_redirect = %i\n", e->override_redirect);

	// The WM must subscribe to property changes, notably to implement the
	// Extended Window Manager Hints (EWMH) propocol
	XSelectInput(aswm->display, e->window, PropertyChangeMask);

	{
		XTextProperty text_property;
		if(XGetWMName(e->display, e->window, &text_property)) {
			printf("\tname: %s\n", text_property.value);
		}
	}
	{
		XClassHint class;
		if(XGetClassHint(e->display, e->window, &class)) {
			printf("\tclass: %s, %s\n", class.res_class, class.res_name);
			XFree(class.res_class);
			XFree(class.res_name);
		}
	}
	if(aswm->workspace_count == 0)
		aswm_create_workspace();
}
